
 
Software for general purpose analysis of charm physics data from a tmQCD mixed action, from mass shift to gevp extraction of the observables to continuum limit fits.

-> src
   |----> aux obs computation
   |	   |------> md.jl : main routine for the computation of delta m and t0 shifted
   |	   |------> tools.jl, types.jl, const.jl : auxiliary files to md.jl
   |
   |-----> gevp analysis: obs. analysis once md.jl has been executed
           |-----> gevp_tm.jl : extract observable ensemble by ensemble using gevp and store in BDIO
           |-----> gevp_fit.jl : read BDIO from previous file and perform chiral-continumm extrapolations
           |-----> func_comb.jl : contains all the functional forms for the chiral-continuum fits
           |-----> gevp_plotter.jl : useful routines for plotting complicated chiral-continuum fits and more
           |-----> read_bdio.jl : reading BDIO routines ( the order is hardcoded but consistent within the whole files)
           |-----> const.jl, tools.jl, types.jl : auxiliary routines for the analysis 
   
   
The GEVP is solved as outlined in 1010.0202, i.e., given a correlator f(t) the following matrix is constructed:

```math
C(t) = \bigg[\begin{matrix} f(t) & f(t+\tau) \\ f(t+\tau) & f(t+2\tau)  \end{matrix} \bigg]
```

The code automatically builds these matrices for PP and PA1 correlators  at each time slice and for each \mu sector outlined by the user in the sector dictionary (ll-hl-sh etc).
After this procedure, the generalised eigenvalues are extracted by solving the equation 
```math
C(t,\tau)v(t,t_0,\tau)  = \lambda(t,t_0, \tau) C(t_0, \tau)v(t,t_0,\tau) 
```
The two time parameters \tau and t_0 can be choosen by the user before compiling the code in the setting options.
The  effective energy spectrum is determined from:
```math
E_n^{eff}(t, t_0, \tau) = \log( \frac{\lambda_n(t, t_0, \tau)}{\lambda_n(t+a, t_0, \tau)}) = E_n + O(e^{-(E_m-e_n)t})  
```
Go to SET UP VARIABLES section  in md.jl, gevp_tm.jl and gevp_fit.jl files to properly configure before running.
Several plauteau and data paths have to be set before running.

Data in  the various path_data need to be stored as follow:

path_data_md : contains pbp.dat files for action derivatives 
 ------> path_data_md/ens_i/*pbp.dat
 
path_data_w: contains wilson light correlators for mass shift  and ms.dat files for t0
------> path_data_w/ens_i/*ms.dat
------> path_data_w/ens_i/*mesons.dat

path_data_rw: contains reweighting factors ms1.dat files
-------> path_data_rw/ens_i/*ms1.dat

path_data_tm: contains twisted mass (heavy) correlators 
--------> path_data_tm/ens_i/*mesons.dat

Replicas are automatically taken into account for each ensembles.

N.B.
In the gamma method the number of configurations of different observables but with same ensemble HAS to match. There might be runs where i.e. ms.dat files contains more cnfgs than mesons.dat files and this generates errors. To avoid it, set in const.jl/trunc_db (database for each ensembles) the number of configurations at which you want to cut all the observables with that ensembe id.


