mutable struct EnsInfo
    id::String
    L::Int64
    beta::Float64
    deg::Bool
    mpi::Float64
    function EnsInfo(ens_id::String, info::Vector{Float64})
        id = ens_id
        L = info[1]
        beta = info[2]
        deg = info[3]
        mpi = info[4]
        return new(id, L, beta, deg, mpi)
    end
end
mutable struct MatInfo
    ensinfo::EnsInfo
    mu::Vector{Float64}
    mat_list::Vector{Matrix{uwreal}}
    y0::Int64
    function MatInfo(_ensinfo::EnsInfo, _mat_list::Array{Array{T,2} where T,1}, _mu::Vector{Float64}, _y0::Int64)
        a = new()
        a.ensinfo = _ensinfo
        a.mu = _mu
        a.mat_list = _mat_list
        a.y0 = _y0
        return a 
    end
end

mutable struct Cat
    obs::Vector{uwreal}
    phih::Vector{uwreal}
    phih_ph::uwreal
    #models::Vector{Vector{Function}}
    x_tofit::Array{uwreal}
    info::String
    fit_param::Vector{Vector{uwreal}}     # store all fit parameters
    fit_res::Vector{uwreal}               # store all fit results
    chi2_vs_exp::Vector{Float64}          # store all chi2 corrected
    n_param::Vector{Int64}                # store the number of parameters. Maybe this is redundant
    aic::Vector{Float64}                  # store the AIC value 
    dof::Vector{Int64}
    function Cat(_obs::Vector{uwreal}, _xtofit::Array{uwreal}, _phi_ph::uwreal, _info::String)
        a = new()
        a.obs         = _obs
        a.info        = _info
        a.x_tofit     = _xtofit
        a.phih_ph     = _phi_ph
        a.fit_param   = Vector{Vector{uwreal}}(undef, 0)
        a.fit_res     = Vector{uwreal}(undef, 0)
        a.chi2_vs_exp = Vector{Float64}(undef, 0)
        a.n_param     = Vector{Int64}(undef, 0)
        a.aic         = Vector{Float64}(undef, 0)
        a.dof         = Vector{Int64}(undef, 0)
        return a 
    end
end