using Base: String
#using Core: Vector
using LaTeXStrings: length
using Revise, juobs, BDIO, DelimitedFiles, ADerrors, PyPlot, LaTeXStrings, LsqFit
##
rcParams = PyPlot.PyDict(PyPlot.matplotlib."rcParams")
rcParams["text.usetex"] = true
rcParams["mathtext.fontset"]  = "cm"
rcParams["font.size"] =11
rcParams["axes.labelsize"] =16

plt.rc("text", usetex=true)
##
#============= SET UP VARIABLES ===========#
<<<<<<< HEAD
const path_data = "/Users/ale/H101r001/dat"
const path_plat = "/Users/ale/automation/plat.txt"
const path_results = "/Users/ale/Desktop/results_gevp"
const path_rw = "/Users/ale/Desktop/data/ms1_dat"
=======
const path_data = "/media/alessandro/4277fef2-edc5-4e0d-89cb-f5d1d44fbc8c/data"
const path_plat = "/home/alessandro/automated-analysis/plat.txt"
const path_results = "/home/alessandro/Desktop/results_gevp"
const path_rw = "/media/alessandro/4277fef2-edc5-4e0d-89cb-f5d1d44fbc8c/data/rwf"
>>>>>>> 1ae3a758e8dc65a7d5326d67c550dd1d1f6fe8ad
const path_md = "/Users/ale/Desktop/data/md_dat"
const path_t0 = "/Users/ale/Desktop/data/t0_shifted.bdio"
const path_deltam = "/Users/ale/Desktop/data/deltam.bdio"
const ens_list = ["H101", "H102r001", "H102r002"]#, "H400", "N202", "N200", "N203", "N300", "J303"]
const bdio_rec = [0, 2, 4, 6, 8, 10, 12, 14, 16 ]
#const ens_list = [ "H400", "N202", "N200", "N203", "N300", "J303"]
#const bdio_rec = [ 6, 8, 10, 12, 14, 16 ]
const sector = Dict("ll"=>true, "ls"=>false, "lh"=>true, "ss"=>false, "sh"=>false, "hh"=>true )
const tau = 3
const _t0 = 2
<<<<<<< HEAD
const range_t_fit = [3,3]
=======
const range_t_fit = [2,5]
>>>>>>> 1ae3a758e8dc65a7d5326d67c550dd1d1f6fe8ad
const rwf = false
const compute_t0 = false
const mass_shift = false 
#go to line 443 to change CL+chiral extrapolation fit model

#========= DO NOT CHANGE AFTER THIS LINE ==========#
##
include("types.jl")
include("tools.jl")
include("const.jl")
include("func_comb.jl")
##
#======== GET ENSEMBLE INFORMATION FROM DATABASE ==========#
ensinfo = Vector{EnsInfo}(undef, length(ens_list))
for i in 1:length(ens_list)
    ens = ens_list[i]
    try
        ensinfo[i]= EnsInfo(ens, ens_db[ens])
    catch
        error("The ensemble id ", ens, " was not found in the const.jl ens_db database.
        Please check the ensemble id or update the database")
    end
end

##
#======== ANALYSIS ==========#
gen_mulist = Vector{Vector{Vector{Float64}}}(undef, length(ens_list))
println("\n Building matrices \n")
@time begin
    matinfo = Vector{Vector{MatInfo}}(undef,length(ens_list))
    matinfo_vec = Vector{Vector{MatInfo}}(undef,length(ens_list))
    for i in 1:length(ensinfo)
        @time begin
            ens = ensinfo[i]
            println("\n Ensemble: ", ens.id)
            pp = get_corr(ens,"G5", "G5", rw=rwf)
            gen_mulist[i] = getfield.(pp, :mu)
            a1a1 = get_corr(ens, "G1G5", "G1G5", rw=rwf)
            matinfo[i] = comp_mat(ens, pp, tau)
            matinfo_vec[i] = comp_mat(ens, a1a1, tau)
            println("Time:")
        end
    end
    println("Total time:")
end

##


##
wpmm = Dict{Int64, Vector{Float64}}()
wpmm[303] = [-1.0, 2.0,-1.0, -1.0]
wpmm[300] = [-1.0, 1.5,-1.0, -1.0]
println("\n Computing observables \n")
@time begin
    ensobs = Vector{EnsObs}(undef, length(ens_list))
    for i in 1:length(ensinfo)
        @time begin
            ens = ensinfo[i]
            println("\n Ensemble: ", ens.id)
            println("\nComputing spectrum...")
            en0_ps = gevp_mass(matinfo[i], t0=_t0, delta_t_in=range_t_fit, wpm=wpmm)
            en0_vec = gevp_mass(matinfo_vec[i], t0=_t0, delta_t_in=range_t_fit, wpm=wpmm)
            println( "\nground  ps mass: ", en0_ps)
            println( "\nground  vec mass: ", en0_vec)
            println("\nComputing decay constants...")
            dec0_ps = gevp_dec(matinfo[i], en0_ps, t0=_t0, n=1, wpm=wpmm, pl=false)
            dec0_vec = gevp_dec(matinfo_vec[i], en0_vec, t0=_t0, n=1, wpm=wpmm, pl=false, pseudo=false)            
            println( "\nground  ps decays: ", dec0_ps)
            println( "\nground  vec decays: ", dec0_vec)
            ensobs[i] = EnsObs(ens, gen_mulist[i], en0_ps, dec0_ps, en0_vec, dec0_vec)
            if ens.deg
                ensobs[i].m_ls = ensobs[i].m_ll
                ensobs[i].m_ls_vec = ensobs[i].m_ll_vec
                ensobs[i].m_ss = ensobs[i].m_ll
                ensobs[i].m_ss_vec = ensobs[i].m_ll_vec
                ensobs[i].m_sh = ensobs[i].m_lh
                ensobs[i].m_sh_vec = ensobs[i].m_lh_vec
                ensobs[i].f_ls = ensobs[i].f_ll
                ensobs[i].f_ls_vec = ensobs[i].f_ll_vec
                ensobs[i].f_ss = ensobs[i].f_ll
                ensobs[i].f_ss_vec = ensobs[i].f_ll_vec
                ensobs[i].f_sh = ensobs[i].f_lh
                ensobs[i].f_sh_vec = ensobs[i].f_lh_vec
            end
            println("Time:")
        end
    end
    println("Total time:")
end

## MASS SHIFTING
if mass_shift
    println("Applying mass corrections")
    # read deltam from BDIO
    #deltam_tmp = []
    #while BDIO_seek!(fb,2)
    #    aux = read_uwreal(fb)
    #    uwerr(aux)
    #    if ensembles(aux)[1] in ens_list
    #        push!(deltam_tmp, aux)
    #    end
    #end


    #reading deltam values
    for i in 1:length(ensobs)
        ens = ensobs[i]
        fb = BDIO_open(path_deltam, "r")
        BDIO_seek!(fb)
        if bdio_rec[i] != 0
            BDIO_seek!(fb, bdio_rec[i])
        end
        println("ensemble ", ens.ensinfo.id)
        println("bdio record ", bdio_rec[i])
        ens.deltam = read_uwreal(fb)
        BDIO_close!(fb)
    end
    
    #applying mass shift to m_ll m_lh m_sh m_hh f_lh f_sh f_hh and vectorial counterpart
    for i in 1:length(ensobs)
        ens = ensobs[i]
        md = read_mass_dev(ens.ensinfo.id)
        #MASSES
        #ll
        println("m_ll")
        println("unshift ", ens.m_ll)
        mdl, mds = md_sea(ens.m_ll, md)
        ens.m_ll += ens.deltam * (2*mdl + mds)
        uwerr(ens.m_ll)
        println("shifted ", ens.m_ll)
        #lh pseudo
        println("\nm_lh")
        uwerr.(ens.m_lh)
        println("unshift ", ens.m_lh)
        mdl1, mds1 = md_sea(ens.m_lh[1], md)
        mdl2, mds2 = md_sea(ens.m_lh[2], md)
        mdl3, mds3 = md_sea(ens.m_lh[3], md)
        ens.m_lh[1] += ens.deltam * (2*mdl1 + mds1)
        ens.m_lh[2] += ens.deltam * (2*mdl2 + mds2)
        ens.m_lh[3] += ens.deltam * (2*mdl3 + mds3)
        uwerr.(ens.m_lh)
        println("shifted", ens.m_lh)
        #lh vec
        println("\nm_lh_vec")
        uwerr.(ens.m_lh_vec)
        println("unshift ", ens.m_lh_vec)
        mdl1, mds1 = md_sea(ens.m_lh_vec[1], md)
        mdl2, mds2 = md_sea(ens.m_lh_vec[2], md)
        mdl3, mds3 = md_sea(ens.m_lh_vec[3], md)
        ens.m_lh_vec[1] += ens.deltam * (2*mdl1 + mds1)
        ens.m_lh_vec[2] += ens.deltam * (2*mdl2 + mds2)
        ens.m_lh_vec[3] += ens.deltam * (2*mdl3 + mds3)
        uwerr.(ens.m_lh_vec)
        println("shifted ", ens.m_lh_vec)
        #sh pseudo
        println("\nm_sh")
        uwerr.(ens.m_sh)
        println("unshift ", ens.m_sh)
        mdl1, mds1 = md_sea(ens.m_sh[1], md)
        mdl2, mds2 = md_sea(ens.m_sh[2], md)
        mdl3, mds3 = md_sea(ens.m_sh[3], md)
        ens.m_sh[1] += ens.deltam * (2*mdl1 + mds1)
        ens.m_sh[2] += ens.deltam * (2*mdl2 + mds2)
        ens.m_sh[3] += ens.deltam * (2*mdl3 + mds3)
        uwerr.(ens.m_sh)
        println("shifted", ens.m_sh)
        #sh vec
        println("\nm_sh_vec")
        uwerr.(ens.m_sh_vec)
        println("unshift ", ens.m_sh_vec)
        mdl1, mds1 = md_sea(ens.m_sh_vec[1], md)
        mdl2, mds2 = md_sea(ens.m_sh_vec[2], md)
        mdl3, mds3 = md_sea(ens.m_sh_vec[3], md)
        ens.m_sh_vec[1] += ens.deltam * (2*mdl1 + mds1)
        ens.m_sh_vec[2] += ens.deltam * (2*mdl2 + mds2)
        ens.m_sh_vec[3] += ens.deltam * (2*mdl3 + mds3)
        uwerr.(ens.m_sh_vec)
        println("shift", ens.m_sh_vec)
        #hh pseudo
        println("\nm_hh")
        uwerr.(ens.m_hh)
        println("unshift ", ens.m_hh)
        mdl1, mds1 = md_sea(ens.m_hh[1], md)
        mdl2, mds2 = md_sea(ens.m_hh[2], md)
        mdl3, mds3 = md_sea(ens.m_hh[3], md)
        ens.m_hh[1] += ens.deltam * (2*mdl1 + mds1)
        ens.m_hh[2] += ens.deltam * (2*mdl2 + mds2)
        ens.m_hh[3] += ens.deltam * (2*mdl3 + mds3)
        uwerr.(ens.m_hh)
        println("shift ", ens.m_hh)
        #hh vec
        println("\nm_hh_vec")
        uwerr.(ens.m_hh_vec)
        println("unshift ", ens.m_hh_vec)
        mdl1, mds1 = md_sea(ens.m_hh_vec[1], md)
        mdl2, mds2 = md_sea(ens.m_hh_vec[2], md)
        mdl3, mds3 = md_sea(ens.m_hh_vec[3], md)
        ens.m_hh_vec[1] += ens.deltam * (2*mdl1 + mds1)
        ens.m_hh_vec[2] += ens.deltam * (2*mdl2 + mds2)
        ens.m_hh_vec[3] += ens.deltam * (2*mdl3 + mds3)
        uwerr.(ens.m_hh_vec)
        println("shift ", ens.m_hh_vec)
        #DECAYS
        #lh pseudo
        println("\nf_lh")
        uwerr.(ens.f_lh)
        println("unshift ", ens.f_lh)
        mdl1, mds1 = md_sea(ens.f_lh[1], md)
        mdl2, mds2 = md_sea(ens.f_lh[2], md)
        mdl3, mds3 = md_sea(ens.f_lh[3], md)
        ens.f_lh[1] += ens.deltam * (2*mdl1 + mds1)
        ens.f_lh[2] += ens.deltam * (2*mdl2 + mds2)
        ens.f_lh[3] += ens.deltam * (2*mdl3 + mds3)
        uwerr.(ens.f_lh)
        println("shifted ", ens.f_lh)
        #lh vec
        println("\nf_lh_vec")
        uwerr.(ens.f_lh_vec)
        println("unshift  ", ens.f_lh_vec)
        mdl1, mds1 = md_sea(ens.f_lh_vec[1], md)
        mdl2, mds2 = md_sea(ens.f_lh_vec[2], md)
        mdl3, mds3 = md_sea(ens.f_lh_vec[3], md)
        ens.f_lh_vec[1] += ens.deltam * (2*mdl1 + mds1)
        ens.f_lh_vec[2] += ens.deltam * (2*mdl2 + mds2)
        ens.f_lh_vec[3] += ens.deltam * (2*mdl3 + mds3)
        uwerr.(ens.f_lh_vec)
        println("shift ", ens.f_lh_vec)
        #sh pseudo
        println("\nf_sh")
        uwerr.(ens.f_sh)
        println("unshift ", ens.f_sh)
        mdl1, mds1 = md_sea(ens.f_sh[1], md)
        mdl2, mds2 = md_sea(ens.f_sh[2], md)
        mdl3, mds3 = md_sea(ens.f_sh[3], md)
        ens.f_sh[1] += ens.deltam * (2*mdl1 + mds1)
        ens.f_sh[2] += ens.deltam * (2*mdl2 + mds2)
        ens.f_sh[3] += ens.deltam * (2*mdl3 + mds3)
        uwerr.(ens.f_sh)
        println("shifted ", ens.f_sh)
        #sh vec
        println("\nf_sh_vec")
        uwerr.(ens.f_sh_vec)
        println("unshift ", ens.f_sh_vec)
        mdl1, mds1 = md_sea(ens.f_sh_vec[1], md)
        mdl2, mds2 = md_sea(ens.f_sh_vec[2], md)
        mdl3, mds3 = md_sea(ens.f_sh_vec[3], md)
        ens.f_sh_vec[1] += ens.deltam * (2*mdl1 + mds1)
        ens.f_sh_vec[2] += ens.deltam * (2*mdl2 + mds2)
        ens.f_sh_vec[3] += ens.deltam * (2*mdl3 + mds3)
        uwerr.(ens.f_sh_vec)
        println("shifted ", ens.f_sh_vec)
        #hh pseudo
        println("\nf_hh")
        uwerr.(ens.f_hh)
        println("unshift ", ens.f_hh)
        mdl1, mds1 = md_sea(ens.f_hh[1], md)
        mdl2, mds2 = md_sea(ens.f_hh[2], md)
        mdl3, mds3 = md_sea(ens.f_hh[3], md)
        ens.f_hh[1] += ens.deltam * (2*mdl1 + mds1)
        ens.f_hh[2] += ens.deltam * (2*mdl2 + mds2)
        ens.f_hh[3] += ens.deltam * (2*mdl3 + mds3)
        uwerr.(ens.f_hh)
        println("shifted ", ens.f_hh)
        #hh vec
        println("\nf_hh_vec")
        uwerr.(ens.f_hh_vec)
        println("unshift ", ens.f_hh_vec)
        mdl1, mds1 = md_sea(ens.f_hh_vec[1], md)
        mdl2, mds2 = md_sea(ens.f_hh_vec[2], md)
        mdl3, mds3 = md_sea(ens.f_hh_vec[3], md)
        ens.f_hh_vec[1] += ens.deltam * (2*mdl1 + mds1)
        ens.f_hh_vec[2] += ens.deltam * (2*mdl2 + mds2)
        ens.f_hh_vec[3] += ens.deltam * (2*mdl3 + mds3)
        uwerr.(ens.f_hh_vec)
        println("shifted ", ens.f_hh_vec)
    end

end


## COLLECT RESULTS AT FINITE LATTICE SPACING

muc = Vector{uwreal}(undef, 0)
phih_eta = Vector{uwreal}(undef, 0) # matching with eta_c
phih_fa = Vector{uwreal}(undef, 0) # matching with flavour average
phi2 = Vector{uwreal}(undef, 0)
t0arr = Vector{uwreal}(undef, 0)
phih_eta_ph =  M_values[5] * t0_ph[1] / hc
phih_fa_ph =  (2/3 * M_values[1] + 1/3 * M_values[3]) * t0_ph[1] / hc
phi2_ph = (t0_ph[1] * 139 / hc)^2 #134.8 isospin breaking pion mass 
uwerr(phi2_ph)
uwerr(phih_eta_ph)
uwerr(phih_fa_ph)
#lh sector
m_D = Vector{uwreal}(undef, 0)
m_D_star =Vector{uwreal}(undef, 0)
f_D= Vector{uwreal}(undef, 0)
f_D_star =Vector{uwreal}(undef, 0)
#sh sector 
m_Ds = Vector{uwreal}(undef, 0)
m_Ds_star =Vector{uwreal}(undef, 0)
f_Ds= Vector{uwreal}(undef, 0)
f_Ds_star =Vector{uwreal}(undef, 0)
# hh 
m_etac = Vector{uwreal}(undef, 0)
m_jpsi =Vector{uwreal}(undef, 0)
f_etac= Vector{uwreal}(undef, 0)
f_jpsi =Vector{uwreal}(undef, 0)
#here i also load t0 from bdio if compute_t0==true, else i load from const.jl
for i in 1:length(ensobs)
    ens = ensobs[i]
    println(ens.ensinfo.id)
    if compute_t0
        fb = BDIO_open(path_t0, "r")
        BDIO_seek!(fb)
        if bdio_rec[i] != 0
            BDIO_seek!(fb, bdio_rec[i])
        end
        ens.t0 = read_uwreal(fb)
        BDIO_close!(fb)
        ens.a = t0_ph[1] / sqrt(8 * ens.t0)
    else
        println("Keep in mind: t0 taken from const.jl - no correlation considered")
        ens.t0 = t0(ens.ensinfo.beta)
        ens.a = a(ens.ensinfo.beta)
    end

    #collect  RGI muh and store in muc
    mul, mus, muh = get_mu(ens.mu_list, ens.ensinfo.deg)
    [push!(muc, zm_tm(ens.ensinfo.beta) * muh[i] * sqrt(8 * ens.t0)) for i in 1:length(muh)]
    #collect t0 for 3 times  and store in t0arr
    [push!(t0arr, ens.t0) for i in 1:length(muh)]
    #collect phih_fa and store in phih_fa
    _8t0m_lh =   (2/3 .* getfield(ens,:m_lh) .+ 1/3 .* getfield(ens,:m_sh))    
    [push!(phih_fa, _8t0m_lh[i] * sqrt(8 * ens.t0)) for i in 1:length(_8t0m_lh)]
    #collect phih_eta and store in phih_eta
    _8t0m_hh =  getfield(ens, :m_hh)    
    [push!(phih_eta, _8t0m_hh[i] * sqrt(8 * ens.t0)) for i in 1:length(_8t0m_hh)]
    #collect phi2 and store in phi2
    sector["ll"] ? phi2_aux = 8 * ens.t0 * ens.m_ll^2 : phi2_aux = 8 * ens.t0 * ens.ensinfo.mpi^2
    #phi2_aux = 8 * ens.t0 * ens.m_ll^2 
    [push!(phi2, phi2_aux) for i in 1:length(muh)]
    
    if sector["lh"]
        aux_lh = getfield(ens, :m_lh)
        [push!(m_D, aux_lh[j] *sqrt(8*ens.t0)) for j in 1:length(aux_lh)]
        aux_lh_vec = getfield(ens, :m_lh_vec)
        [push!(m_D_star, aux_lh_vec[j] *sqrt(8*ens.t0)) for j in 1:length(aux_lh)]
        aux_lh = getfield(ens, :f_lh)
        [push!(f_D, aux_lh[j] *sqrt(8*ens.t0)) for j in 1:length(aux_lh)]
        aux_lh_vec = getfield(ens, :f_lh_vec)
        [push!(f_D_star, za(ens.ensinfo.beta) * aux_lh_vec[j] *sqrt(8*ens.t0)) for j in 1:length(aux_lh)]
    end 
    if sector["sh"]
        aux_sh = getfield(ens, :m_sh)
        [push!(m_Ds, aux_sh[j] *sqrt(8*ens.t0)) for j in 1:length(aux_sh)]
        aux_sh_vec = getfield(ens, :m_sh_vec)
        [push!(m_Ds_star, aux_sh_vec[j] *sqrt(8*ens.t0)) for j in 1:length(aux_sh)]
        aux_sh = getfield(ens, :f_sh)
        [push!(f_Ds, aux_sh[j] *sqrt(8*ens.t0)) for j in 1:length(aux_sh)]
        aux_sh_vec = getfield(ens, :f_sh_vec)
        [push!(f_Ds_star, za(ens.ensinfo.beta) * aux_sh_vec[j] *sqrt(8*ens.t0)) for j in 1:length(aux_sh)]
    end
    if sector["hh"]
        aux_hh = getfield(ens, :m_hh)
        [push!(m_etac, aux_hh[j] *sqrt(8*ens.t0)) for j in 1:length(aux_hh)]
        aux_hh_vec = getfield(ens, :m_hh_vec)
        [push!(m_jpsi, aux_hh_vec[j] *sqrt(8*ens.t0)) for j in 1:length(aux_hh)]
        aux_hh = getfield(ens, :f_hh)
        [push!(f_etac, aux_hh[j] *sqrt(8*ens.t0)) for j in 1:length(aux_hh)]
        aux_hh_vec = getfield(ens, :f_hh_vec)
        [push!(f_jpsi, za(ens.ensinfo.beta) * aux_hh_vec[j] *sqrt(8*ens.t0)) for j in 1:length(aux_hh)]
    end
    
end

# prepare observables for ensembles with beta>3.4
muc_sub = Vector{uwreal}(undef, 0)
phih_eta_sub = Vector{uwreal}(undef, 0) # matching with eta_c
phih_fa_sub = Vector{uwreal}(undef, 0) # matching with flavour average
phi2_sub = Vector{uwreal}(undef, 0)
t0arr_sub = Vector{uwreal}(undef, 0)
#lh sector
m_D_sub = Vector{uwreal}(undef, 0)
m_D_star_sub =Vector{uwreal}(undef, 0)
f_D_sub = Vector{uwreal}(undef, 0)
f_D_star_sub =Vector{uwreal}(undef, 0)
#sh sector 
m_Ds_sub = Vector{uwreal}(undef, 0)
m_Ds_star_sub =Vector{uwreal}(undef, 0 )
f_Ds_sub = Vector{uwreal}(undef, 0)
f_Ds_star_sub =Vector{uwreal}(undef, 0)
# hh 
m_etac_sub = Vector{uwreal}(undef, 0)
m_jpsi_sub =Vector{uwreal}(undef, 0)
f_etac_sub = Vector{uwreal}(undef, 0)
f_jpsi_sub =Vector{uwreal}(undef, 0)

# ensembles with beta>3.4
sub_ens_index = findall(x->x>3.4, getfield.(getfield.(ensobs,:ensinfo), :beta))

for index in sub_ens_index
    [push!(muc_sub, muc[3*(index-1) + i]) for i in 1:3]
    [push!(phih_eta_sub, phih_eta[3*(index-1) + i]) for i in 1:3]
    [push!(phih_fa_sub, phih_fa[3*(index-1) + i]) for i in 1:3]
    [push!(phi2_sub, phi2[3*(index-1) + i]) for i in 1:3]
    [push!(t0arr_sub, t0arr[3*(index-1) + i]) for i in 1:3]
    #lh sector
    [push!(m_D_sub, m_D[3*(index-1) + i]) for i in 1:3]
    [push!(m_D_star_sub, m_D_star[3*(index-1) + i]) for i in 1:3]
    [push!(f_D_sub, f_D[3*(index-1) + i]) for i in 1:3]
    [push!(f_D_star_sub, f_D_star[3*(index-1) + i]) for i in 1:3]
    #sh sector
    [push!(m_Ds_sub, m_Ds[3*(index-1) + i]) for i in 1:3]
    [push!(m_Ds_star_sub, m_Ds_star[3*(index-1) + i]) for i in 1:3]
    [push!(f_Ds_sub, f_Ds[3*(index-1) + i]) for i in 1:3]
    [push!(f_Ds_star_sub, f_Ds_star[3*(index-1) + i]) for i in 1:3]
    #hh sector
    [push!(m_etac_sub, m_etac[3*(index-1) + i]) for i in 1:3]
    [push!(m_jpsi_sub, m_jpsi[3*(index-1) + i]) for i in 1:3]
    [push!(f_etac_sub, f_etac[3*(index-1) + i]) for i in 1:3]
    [push!(f_jpsi_sub, f_jpsi[3*(index-1) + i]) for i in 1:3]
end

##

# Now i need to create different categories 
# x values for fit_routine for different categories 
x_fa = [1 ./(8 .* t0arr) phi2 phih_fa]
x_eta = [1 ./(8 .* t0arr) phi2 phih_eta]
x_fa_sub = [1 ./(8 .* t0arr_sub) phi2_sub phih_fa_sub]
x_eta_sub = [1 ./(8 .* t0arr_sub) phi2_sub phih_eta_sub]



# muc
cat_muc = Vector{Cat}(undef, 0)
push!(cat_muc, Cat(muc, x_fa , phih_fa_ph ,"muc, all_ens, fl_ave"))
push!(cat_muc, Cat(muc, x_eta , phih_eta_ph, "muc, all_ens, etac"))
push!(cat_muc, Cat(muc_sub, x_fa_sub , phih_fa_ph,"muc, sub_ens, fl_ave"))
push!(cat_muc, Cat(muc_sub, x_eta_sub , phih_eta_ph,"muc, sub_ens, etac"))
# m_etac
cat_m_eta = Vector{Cat}(undef, 0)
push!(cat_m_eta, Cat(m_etac, x_fa , phih_fa_ph ,"m_etac, all_ens, fl_ave"))
push!(cat_m_eta, Cat(m_etac, x_eta , phih_eta_ph, "m_etac, all_ens, etac"))
push!(cat_m_eta, Cat(m_etac_sub, x_fa_sub , phih_fa_ph,"m_etac, sub_ens, fl_ave"))
push!(cat_m_eta, Cat(m_etac_sub, x_eta_sub , phih_eta_ph,"m_etac, sub_ens, etac"))
# m_jpsi
cat_m_jpsi = Vector{Cat}(undef, 0)
push!(cat_m_jpsi, Cat(m_jpsi, x_fa , phih_fa_ph ,"m_jpsi, all_ens, fl_ave"))
push!(cat_m_jpsi, Cat(m_jpsi, x_eta , phih_eta_ph, "m_jpsi, all_ens, etac"))
push!(cat_m_jpsi, Cat(m_jpsi_sub, x_fa_sub , phih_fa_ph,"m_jpsi, sub_ens, fl_ave"))
push!(cat_m_jpsi, Cat(m_jpsi_sub, x_eta_sub , phih_eta_ph,"m_jpsi, sub_ens, etac"))
# m_D
cat_m_D = Vector{Cat}(undef, 0)
push!(cat_m_D, Cat(m_D, x_fa , phih_fa_ph ,"m_D, all_ens, fl_ave"))
push!(cat_m_D, Cat(m_D, x_eta , phih_eta_ph, "m_D, all_ens, etac"))
push!(cat_m_D, Cat(m_D_sub, x_fa_sub , phih_fa_ph,"m_D, sub_ens, fl_ave"))
push!(cat_m_D, Cat(m_D_sub, x_eta_sub , phih_eta_ph,"m_D, sub_ens, etac"))
# m_D_star
cat_m_D_star = Vector{Cat}(undef, 0)
push!(cat_m_D_star, Cat(m_D_star, x_fa , phih_fa_ph ,"m_D_star, all_ens, fl_ave"))
push!(cat_m_D_star, Cat(m_D_star, x_eta , phih_eta_ph, "m_D_star, all_ens, etac"))
push!(cat_m_D_star, Cat(m_D_star_sub, x_fa_sub , phih_fa_ph,"m_D_star, sub_ens, fl_ave"))
push!(cat_m_D_star, Cat(m_D_star_sub, x_eta_sub , phih_eta_ph,"m_D_star, sub_ens, etac"))
# m_Ds
cat_m_Ds = Vector{Cat}(undef, 0)
push!(cat_m_Ds, Cat(m_Ds, x_fa , phih_fa_ph ,"m_Ds, all_ens, fl_ave"))
push!(cat_m_Ds, Cat(m_Ds, x_eta , phih_eta_ph, "m_Ds, all_ens, etac"))
push!(cat_m_Ds, Cat(m_Ds_sub, x_fa_sub , phih_fa_ph,"m_Ds, sub_ens, fl_ave"))
push!(cat_m_Ds, Cat(m_Ds_sub, x_eta_sub , phih_eta_ph,"m_Ds, sub_ens, etac"))
# m_Ds_star
cat_m_Ds_star = Vector{Cat}(undef, 0)
push!(cat_m_Ds_star, Cat(m_Ds_star, x_fa , phih_fa_ph ,"m_Ds_star, all_ens, fl_ave"))
push!(cat_m_Ds_star, Cat(m_Ds_star, x_eta , phih_eta_ph, "m_Ds_star, all_ens, etac"))
push!(cat_m_Ds_star, Cat(m_Ds_star_sub, x_fa_sub , phih_fa_ph,"m_Ds_star, sub_ens, fl_ave"))
push!(cat_m_Ds_star, Cat(m_Ds_star_sub, x_eta_sub , phih_eta_ph,"m_Ds_star, sub_ens, etac"))


mass_cat = [cat_muc, cat_m_eta, cat_m_jpsi,  cat_m_D, cat_m_D_star, cat_m_Ds, cat_m_Ds_star]
##
for elem in mass_cat    
    for i in 1:length(elem)
        cat = elem[i]
        println("\n", cat.info, "\n")
        for j  in 1:length(f)             # looping over number of parameters
            for k in 1:length(f[j]) # looping over combinations with fixed parameters 
                println(" j is :", j, " k is equal: ", k)
                try
                    par, chi_corr = fit_routine(f[j][k],cat.x_tofit, cat.obs, n_param[j], covar=true, wpm=wpmm)
                    aux = par[1] + par[2]*phi2_ph + par[3]*cat.phih_ph
                    uwerr(aux)
                    push!(cat.fit_res, aux)
                    push!(cat.fit_param, par)
                    push!(cat.chi2_corr, chi_corr)
                    push!(cat.n_param, n_param[j])
                    push!(cat.aic, chi_corr +2*n_param[j])
                catch
                    println("There was a problem... Probably the analysis failed for some error id.")
                    println("The result has been excluded from the category")
                end    
            end
        end

    end
end
##
#res = getfield.(cat_m_Ds_star, :fit_res)
#syst = aic_syst.(cat_m_Ds_star)
#best = aic_model_ave.(cat_m_Ds_star)
#color = ["tomato", "green", "royalblue", "orange"]
#fig = figure()
#    for i in 1:length(res)
#        label = cat_m_Ds_star[i].info
#        errorbar(collect(1:length(res[i])), value.(res[i]), yerr=err.(res[i]), fmt="*", label=label, alpha=0.8,c=color[i], mfc=color[i])
#        fill_between(collect(1:length(res[i])),value(best[i])-syst[i],value(best[i])+syst[i], alpha=0.5, color=color[i]  )
#        errorbar(-8+i, value(best[i]), yerr=err(best[i]), fmt="d", c=color[i], mfc=color[i])
#    end
#    #ylim(2.8, 3.3)
#    legend()
#    ylabel(L"$M_{Ds_*}\sqrt{8t_0}$")
#    xlabel("Models")
#    savefig("/Users/ale/Desktop/test_m_Ds_star.pdf")
#display(fig)
#
##
# f_etac
cat_f_eta = Vector{Cat}(undef, 0)
push!(cat_f_eta, Cat(f_etac, x_fa , phih_fa_ph ,"f_etac, all_ens, fl_ave"))
push!(cat_f_eta, Cat(f_etac, x_eta , phih_eta_ph, "f_etac, all_ens, etac"))
push!(cat_f_eta, Cat(f_etac_sub, x_fa_sub , phih_fa_ph,"f_etac, sub_ens, fl_ave"))
push!(cat_f_eta, Cat(f_etac_sub, x_eta_sub , phih_eta_ph,"f_etac, sub_ens, etac"))
# f_jpsi
cat_f_jpsi = Vector{Cat}(undef, 0)
push!(cat_f_jpsi, Cat(f_jpsi, x_fa , phih_fa_ph ,"f_jpsi, all_ens, fl_ave"))
push!(cat_f_jpsi, Cat(f_jpsi, x_eta , phih_eta_ph, "f_jpsi, all_ens, etac"))
push!(cat_f_jpsi, Cat(f_jpsi_sub, x_fa_sub , phih_fa_ph,"f_jpsi, sub_ens, fl_ave"))
push!(cat_f_jpsi, Cat(f_jpsi_sub, x_eta_sub , phih_eta_ph,"f_jpsi, sub_ens, etac"))
# f_D
cat_f_D = Vector{Cat}(undef, 0)
push!(cat_f_D, Cat(f_D, x_fa , phih_fa_ph ,"f_D, all_ens, fl_ave"))
push!(cat_f_D, Cat(f_D, x_eta , phih_eta_ph, "f_D, all_ens, etac"))
push!(cat_f_D, Cat(f_D_sub, x_fa_sub , phih_fa_ph,"f_D, sub_ens, fl_ave"))
push!(cat_f_D, Cat(f_D_sub, x_eta_sub , phih_eta_ph,"f_D, sub_ens, etac"))
# f_D_star
cat_f_D_star = Vector{Cat}(undef, 0)
push!(cat_f_D_star, Cat(f_D_star, x_fa , phih_fa_ph ,"f_D_star, all_ens, fl_ave"))
push!(cat_f_D_star, Cat(f_D_star, x_eta , phih_eta_ph, "f_D_star, all_ens, etac"))
push!(cat_f_D_star, Cat(f_D_star_sub, x_fa_sub , phih_fa_ph,"f_D_star, sub_ens, fl_ave"))
push!(cat_f_D_star, Cat(f_D_star_sub, x_eta_sub , phih_eta_ph,"f_D_star, sub_ens, etac"))
# f_Ds
cat_f_Ds = Vector{Cat}(undef, 0)
push!(cat_f_Ds, Cat(f_Ds, x_fa , phih_fa_ph ,"f_Ds, all_ens, fl_ave"))
push!(cat_f_Ds, Cat(f_Ds, x_eta , phih_eta_ph, "f_Ds, all_ens, etac"))
push!(cat_f_Ds, Cat(f_Ds_sub, x_fa_sub , phih_fa_ph,"f_Ds, sub_ens, fl_ave"))
push!(cat_f_Ds, Cat(f_Ds_sub, x_eta_sub , phih_eta_ph,"f_Ds, sub_ens, etac"))
# f_Ds_star
cat_f_Ds_star = Vector{Cat}(undef, 0)
push!(cat_f_Ds_star, Cat(f_Ds_star, x_fa , phih_fa_ph ,"f_Ds_star, all_ens, fl_ave"))
push!(cat_f_Ds_star, Cat(f_Ds_star, x_eta , phih_eta_ph, "f_Ds_star, all_ens, etac"))
push!(cat_f_Ds_star, Cat(f_Ds_star_sub, x_fa_sub , phih_fa_ph,"f_Ds_star, sub_ens, fl_ave"))
push!(cat_f_Ds_star, Cat(f_Ds_star_sub, x_eta_sub , phih_eta_ph,"f_Ds_star, sub_ens, etac"))

## here i perform the fit for all dec const categories 
f_cat = [ cat_f_eta, cat_f_jpsi, cat_f_D, cat_f_D_star, cat_f_Ds, cat_f_Ds_star]

for elem in f_cat    
    for i in 1:length(elem)
        cat = elem[i]
        println("\n", cat.info, "\n")
        for j  in 1:length(f_dec)             # looping over number of parameters
            for k in 1:length(f_dec[j]) # looping over combinations with fixed parameters 
                println(" j is :", j, " k is equal: ", k)
                try
                    par, chi_corr = fit_routine(f_dec[j][k],cat.x_tofit, cat.obs, n_param[j], covar=true, wpm=wpmm)
                    aux = par[1] + par[2]*phi2_ph + par[3]/sqrt(cat.phih_ph)
                    uwerr(aux)
                    println(aux)
                    push!(cat.fit_res, aux)
                    push!(cat.fit_param, par)
                    push!(cat.chi2_corr, chi_corr)
                    push!(cat.n_param, n_param[j])
                    push!(cat.aic, chi_corr +2*n_param[j])
                catch
                    println("There was a problem... Probably the analysis failed for some error id.")
                    println("The result has been excluded from the category")
                end    
            end
        end

    end
end

##


res = getfield.(cat_f_D_star, :fit_res)
syst = aic_syst.(cat_f_D_star)
best = aic_model_ave.(cat_f_D_star)
color = ["tomato", "green", "royalblue", "orange"]
fig = figure()
    for i in 1:length(res)
        label = cat_f_D_star[i].info
        errorbar(collect(1:length(res[i])), value.(res[i]), yerr=err.(res[i]), fmt="*", label=label, alpha=0.8,c=color[i], mfc=color[i])
        fill_between(collect(1:length(res[i])),value(best[i])-syst[i],value(best[i])+syst[i], alpha=0.5, color=color[i]  )
        errorbar(-8+i, value(best[i]), yerr=err(best[i]), fmt="d", c=color[i], mfc=color[i])
    end
    #ylim(.6, 1.2)
    legend()
    ylabel(L"$f_{D_*}\sqrt{8t_0}$")
    xlabel("Models")
    savefig("/Users/ale/Desktop/test_f_D_star.pdf")
display(fig)

## ##################################### SO FAR SO GOOD
#========= RESULTS =========#
label_masses = ["muc", "m_etac", "m_jpsi", "m_D", "m_D_star", "m_Ds", "m_Ds_star"]
fin_masses = []
fin_masses_syst = []
fin_masses_ph = []
fin_masses_ph_syst = []
for obs in mass_cat
    aux, syst_fin = category_av(obs)
    push!(fin_masses, aux )
    push!(fin_masses_syst, syst_fin )
    push!(fin_masses_ph, aux*hc/ t0_ph[1])
    push!(fin_masses_ph_syst, value(syst_fin*hc/t0_ph[1]))
end
uwerr.(fin_masses)
uwerr.(fin_masses_ph)

label_dec = [ "f_etac", "f_jpsi", "f_D", "f_D_star", "f_Ds", "f_Ds_star"]
fin_f = []
fin_f_syst = []
fin_f_ph = []
fin_f_ph_syst = []
for obs in f_cat
    aux, syst_fin= category_av(obs)
    push!(fin_f, aux )
    push!(fin_f_syst, syst_fin )
    push!(fin_f_ph, aux*hc/ t0_ph[1])
    push!(fin_f_ph_syst, value(syst_fin*hc/t0_ph[1]))
end
uwerr.(fin_f)
uwerr.(fin_f_ph)

lab_mass_latex =[L"$\sqrt{8t_0}Z^{tm}_M\mu_c$",L"$\sqrt{8t_0}m_{\eta_c}$",L"$\sqrt{8t_0}m_{J/ψ}$",L"$\sqrt{8t_0}m_D$", L"$\sqrt{8t_0}m_{D^*}$", L"$\sqrt{8t_0}m_{D_s}$", L"$\sqrt{8t_0}m_{D_s^*}$"] 
lab_f_latex = [L"$\sqrt{8t_0}f_{\eta_c}$",L"$\sqrt{8t_0}Z_Af_{J/ψ}$",L"$\sqrt{8t_0}f_D$", L"$\sqrt{8t_0}Z_Af_{D^*}$", L"$\sqrt{8t_0}f_{D_s}$", L"$\sqrt{8t_0}Z_Af_{D_s^*}$"] 

##======== STORE RESULTS ========#

open(joinpath(path_results, "results.txt"), "w") do f 
    print(f, "GEVP analysis results", "\n \n")
    print(f, "#================================# \n \n")
    print(f, "Setup:\n")
    print(f, "Ensembles analysed: ", ens_list, "\n")
    print(f, "Data storage: ", path_data, "\n")
    print(f, "Plateaux file: ", path_plat, "\n")
    print(f, "Results storage: ", path_results, "\n")
    print(f, "Sector analysed: ", findall(sector), "\n")
    print(f, "Reweighting factor: ", rwf, "\n")
    print(f, "Mass shift: ", mass_shift, "\n")
    if compute_t0
        print(f, "t0 values: computed from the ms.dat files \n")
    else
        print(f, "t0 values: extracted from const.jl \n")
    end
    if sector["ll"]
        print(f, "Phi2 = 8t0m_pi^2: m_pi computed from mesons.dat files \n")
    else
        print(f, "Phi2 = 8t0m_pi^2: m_pi extracted from ens_db in const.jl \n")
    end
    print(f, " \n#================================# \n \n")
    #print(f, "\n Results at finite lattice spacings \n \n")
#
    #lab = findall(sector)
    #for i in 1:length(ensembles)
    #    print(f, "Ensemble ", ensobs[i].ensinfo.id, "\n")
    #    for j in 1:length(obs)
    #        print(f, ylbl[j], " = ", obs[j][i], "\n")
    #    end
    #    print(f, "\n")
    #end
#
    print(f, " \n#================================# \n \n")
    print(f, "\n Results in the continuum limit \n \n")
    for k = 1:length(fin_masses)
        print(f, lab_mass_latex[k], " = ", fin_masses[k], " +/- ", fin_masses_syst[k], "\n")
        #phys
        print(f, label_masses[k], "(MeV) = ", fin_masses_ph[k], " +/- ", fin_masses_ph_syst[k], "\n\n")
    end
    for k = 1:length(fin_f)
        print(f, lab_f_latex[k], " = ", fin_f[k], " +/- ", fin_f_syst[k], "\n")
        #phys
        print(f, label_dec[k], "(MeV) = ", fin_f_ph[k], " +/- ", fin_f_ph_syst[k], "\n\n")
    end
end


## PLOTS 
font = {"size"   : 22}

matplotlib.rc("font", **font)
function plot_hist(cat::Vector{Cat} ; save::Bool=false)
    best = category_av(cat)[1] *hc /t0_ph[1]
    println(best)
    all_res_aux = vcat(getfield.(cat, :fit_res) .* hc... )
    all_res = [all_res_aux[i] /t0_ph[1] for i =1:length(all_res_aux)]
    println(length(all_res))
    uwerr.(all_res)
    uwerr(best)
    fig = figure()
        hist(value.(all_res), bins=50, density=true, histtype="stepfilled", facecolor="royalblue",ec="k", alpha=0.3)
        fill_betweenx(collect(0:5), value(best)-err(best)+4,value(best)+err(best)-4, color="tomato", alpha=0.4)
        axvline(value(best),0, 5, color="tomato", label="best estimate" )
        xlim(1490, 1540)
        ylim(0,0.1)
        ylabel("Probability")
        xlabel(L"$M_c^{\rm{RGI}}\ [\rm{MeV}]$")
        legend()
    display(fig)
    if save
        path_plot= "/Users/ale/Desktop/plots"
        t = string("hist_muc.pdf")
        savefig(joinpath(path_plot,t))
    end
    close()
end
##
function plot_cat(cat::Cat, ylab::LaTeXString ; cut::Float64=2.5, save::Bool=false)
    aic = getfield(cat, :aic)
    aic_norm_index = findall(x-> x<cut,aic / minimum(aic))
    aic = aic[aic_norm_index] / minimum(aic)
    best = aic_model_ave(cat) * hc /t0_ph[1]
    syst = aic_syst(cat) *hc /t0_ph[1]
    uwerr(syst)
    all_res_aux = getfield(cat, :fit_res) .* hc 
    all_res_aux = all_res_aux[aic_norm_index]
    all_res = [all_res_aux[i] /t0_ph[1] for i =1:length(all_res_aux)]
    uwerr.(all_res)
    uwerr(best)
    fig = figure()
        cm = get_cmap("Greys")
        fill_between(collect(1:length(all_res)), value(best-syst), value(best+syst), alpha=0.5, color="tomato", label="Systematics")
        sc = scatter(collect(1:length(all_res)), value.(all_res), edgecolors="black",c=1 ./aic, cmap=cm, vmin=minimum(1 ./aic), vmax=1 , zorder=3)
        errorbar(collect(1:length(all_res)), value.(all_res), yerr=err.(all_res), fmt="none",zorder=0, capsize=2,marker="none", lw=0.8,  mec="black", ecolor="black")
        errorbar(-2, value(best), yerr=err(best), fmt="s",mfc="tomato",ms=8, mec="tomato",ecolor="tomato", capsize=2, zorder=0, label="Model average")
        xlabel("Models")
        ylabel(ylab)
        cb = colorbar(sc)
        cb[:set_label]("AIC weigths")
        #legend()
    display(fig)
    if save
        path_plot= "/Users/ale/Desktop/plots"
        t = string("cat_ave_", cat.info, ".pdf")
        savefig(joinpath(path_plot,t))
    end
end

##


## plotting the cont limit scaling 

function plot_cont_lim(cat::Cat, ff::Vector{Vector{Function}}, ylab::LaTeXString; dec::Bool=false,save::Bool=false)
    aic, idx = findmin(getfield(cat, :aic)) # best fit
    par_n = getfield(cat, :n_param)[idx] # best n of parameters
    model = vcat(ff...)[par_n]            #best model
    fit_par = cat.fit_param[par_n]
    best_res = cat.fit_res[par_n]
    println(fit_par[1:par_n])
    x = getfield(cat,:x_tofit)
    obs = cat.obs
    obs_match = Vector{uwreal}(undef,length(ens_list))
    k=1
    for i =1:Int64(length(obs)/3)
        mul,mus, muh = get_mu(gen_mulist[i], ensinfo[i].deg)
        println(muh)
        println(x[k:k+2,3])
        muh_target = match_phih(muh, x[k:k+2,3],cat.phih_ph)
        par, chi2exp = lin_fit(muh, obs[k:k+2])
        obs_aux = y_lin_fit(par, value(muh_target))
        obs_match[i] = obs_aux
        k+=3
    end
    println(obs_match)
    uwerr.(obs_match)
    x_a2 = Float64.(range(0.0, stop=0.05, length=100))
    x_new = [x_a2 repeat([value(phi2_ph)],100) repeat([value(cat.phih_ph)],100)]
    xarr = Float64.(range(0.0, stop=0.06, length=100))
    y = Vector{uwreal}(undef, 100)
    if !dec    
        for j=1:100
            y[j] = fit_par[1] + fit_par[2] * phi2_ph + fit_par[3] * cat.phih_ph + fit_par[4] * xarr[j] + fit_par[5] * xarr[j] *phi2_ph^2   + fit_par[7]*xarr[j]*cat.phih_ph^2 + fit_par[8]*xarr[j]^4*cat.phih_ph^3
        end
    else
        for j=1:100
            y[j] = fit_par[1] + fit_par[2] * phi2_ph + fit_par[3] / sqrt(cat.phih_ph) + fit_par[4] * xarr[j]
        end
    end
    uwerr.(y)
    figure()
    xx = 1 ./ (8 .* getfield.(ensobs, :t0))
    uwerr.(xx)
    for b in unique(getfield.(ensinfo,:beta))
        nn = findall(x->x==b, getfield.(ensinfo,:beta) )
        lgnd = string(L"$\beta = $",b)
        errorbar(value.(xx[nn]), value.(obs_match[nn]),xerr = err.(xx[nn]), yerr=err.(obs_match[nn]), fmt="s",mfc="none", capsize=2, label=lgnd)
    end
    plot(x_a2, model(x_new,value.(fit_par)), color="tomato" )
    xlabel(L"$a^2/8t_0$")
    ylabel(ylab)
    fill_between(xarr, value.(y) .+ err.(y),value.(y) .- err.(y) , color="tomato", alpha=0.4,zorder=1, lw=0.8)
    errorbar(0, value(best_res), err(best_res), fmt="s", capsize=2, mec="red", mfc="red", ecolor="red", label="CL")
    #ylim(2.9,3.4)
    xlim(-0.003,0.05)
    axvline(0, ls="--", color="black", zorder=1, lw=0.6, label="")
    legend(ncol=2)
    display(gcf())
    println("par n is ", par_n)
    if save
        path_plot= "/Users/ale/Desktop/plots"
        t = string("fit_", cat.info, ".pdf")
        savefig(joinpath(path_plot,t))
    end
    close()
end

function plot_cont_lim_phi2(cat::Cat, ff::Vector{Vector{Function}}, ylab::LaTeXString; dec::Bool=false,save::Bool=false)
    aic, idx = findmin(getfield(cat, :aic)) # best fit
    par_n = getfield(cat, :n_param)[3] #here 2 shoudl be idx best n of parameters
    model = vcat(ff...)[3]            #best model
    fit_par = cat.fit_param[3]
    best_res = cat.fit_res[3]
    println("best res is ", best_res)
    x = getfield(cat,:x_tofit)
    obs = cat.obs
    obs_match = Vector{uwreal}(undef,length(ens_list))
    k=1
    for i =1:Int64(length(obs)/3)
        mul,mus, muh = get_mu(gen_mulist[i], ensinfo[i].deg)
        println(muh)
        println(x[k:k+2,3])
        muh_target = match_phih(muh, x[k:k+2,3],cat.phih_ph)
        par, chi2exp = lin_fit(muh, obs[k:k+2])
        obs_aux = y_lin_fit(par, value(muh_target))
        obs_match[i] = obs_aux
        k+=3
    end
    println(obs_match)
    uwerr.(obs_match)
    xarr = Float64.(range(0.0, stop=0.9, length=100))
    y = Vector{uwreal}(undef, 100)
    if !dec    
        for j=1:100
            y[j] = fit_par[1] + fit_par[2] *  xarr[j] + fit_par[3] * cat.phih_ph 
        end
    else
        for j=1:100
            y[j] = fit_par[1] + fit_par[2] *  xarr[j]  + fit_par[3] / sqrt(cat.phih_ph) 
        end
    end
    uwerr.(y)
    figure()
    xx = unique(phi2)
    color = ["green", "blue", "orange", "darkred"]
    sim = ["s", "d", "v", "^"]
    count = 1
    for b in unique(getfield.(ensinfo,:beta))
        nn = findall(x->x==b, getfield.(ensinfo,:beta) )
        if length(nn) >1
            xxx = Float64.(range(0.0, stop=0.9, length=100))
            if b != 3.40
                println(fit_par[2])
                @. lin_mod(x,p) = p[1] + x*p[2]
                #fitp, csqexp = fit_routine(lin_mod, value.(x[nn]), obs_match[nn],2)
                #plot(xxx, value(fitp[1]) .+ value(fit_par[2]) .* xxx, color=color[count], ls="--", lw="0.5")
                fitp, csqexp = lin_fit(value.(xx[nn]), obs_match[nn])
                #println("at beta ", b, " ", fitp)
                #println("\n", xx[nn] )
                #xxx = Float64.(range(0.0, stop=0.9, length=100))
                if b == 3.55
                    fitp[1]-=0.007
                end
                plot(xxx, value(fitp[1]) .+ xxx .* value(fit_par[2]), color=color[count], ls="--", lw="0.5")
            else
                plot(xxx, 0.563 .+ xxx .* value(fit_par[2]), color=color[count], ls="--", lw="0.5")
            end
        else
            xxx = Float64.(range(0.0, stop=0.9, length=100))
            plot(xxx, 0.548 .+ xxx .*  value(fit_par[2]), color=color[count], ls="--", lw="0.5")
        end

        lgnd = string(L"$\beta = $",b)
        errorbar(value.(xx[nn]), value.(obs_match[nn]),xerr = err.(xx[nn]), yerr=err.(obs_match[nn]), ms=8, fmt=sim[count],mfc="none",mec=color[count], ecolor=color[count], capsize=2, label=lgnd)
        count += 1
    end
    xlabel(L"$\Phi_2=8t_0m_{\pi}^2$")
    ylabel(ylab)
    fill_between(xarr, value.(y) .+ err.(y),value.(y) .- err.(y) , color="tomato", alpha=0.4,zorder=1, lw=0.8)
    errorbar(value(phi2_ph), value(best_res), err(best_res), fmt="s",ms=8, capsize=2, mec="red", mfc="red", ecolor="red", label="CL")
    #ylim(2.9,3.4)
    xlim(0,0.9)
    axvline(value(phi2_ph), ls="--", color="black", zorder=1, lw=0.6, label=L"$\Phi_2^{\rm{phys}}$")
    legend(ncol=2,loc="lower left")
    display(gcf())
    if save
        path_plot= "/Users/ale/Desktop/plots"
        t = string("fit_phi2_", cat.info, ".pdf")
        savefig(joinpath(path_plot,t))
    end
    close()
end


## TEST CONT LIM muc

function plot_cont_lim( ff::Vector{Vector{Function}}, ylab::LaTeXString; dec::Bool=false,save::Bool=false)
    cat = cat_muc[1]
    cat2 = cat_muc[2]

    aic, idx = findmin(getfield(cat, :aic)) # best fit
    par_n = getfield(cat, :n_param)[2] # best n of parameters
    model = vcat(ff...)[par_n]            #best model
    fit_par = cat.fit_param[par_n]
    best_res = cat.fit_res[par_n]
    x = getfield(cat,:x_tofit)
    obs = cat.obs
    obs_match = Vector{uwreal}(undef,length(ens_list))
    
    aic2, idx2 = findmin(getfield(cat2, :aic)) # best fit
    par_n2 = getfield(cat2, :n_param)[26] # best n of parameters
    model2 = vcat(ff...)[par_n2]            #best model
    fit_par2 = cat2.fit_param[par_n2]
    best_res2 = cat2.fit_res[par_n2]
    x2 = getfield(cat2,:x_tofit)
    obs2 = cat2.obs
    obs_match2 = Vector{uwreal}(undef,length(ens_list))
    
    k=1
    for i =1:Int64(length(obs)/3)
        mul,mus, muh = get_mu(gen_mulist[i], ensinfo[i].deg)
        println(muh)
        println(x[k:k+2,3])
        muh_target = match_phih(muh, x[k:k+2,3],cat.phih_ph)
        par, chi2exp = lin_fit(muh, obs[k:k+2])
        obs_aux = y_lin_fit(par, value(muh_target))
        obs_match[i] = obs_aux
        k+=3
    end
    k=1
    for i =1:Int64(length(obs2)/3)
        mul,mus, muh = get_mu(gen_mulist[i], ensinfo[i].deg)
        println(muh)
        println(x2[k:k+2,3])
        muh_target = match_phih(muh, x2[k:k+2,3],cat2.phih_ph)
        par, chi2exp = lin_fit(muh, obs2[k:k+2])
        obs_aux = y_lin_fit(par, value(muh_target))
        obs_match2[i] = obs_aux
        k+=3
    end

    uwerr.(obs_match)
    uwerr.(obs_match2)

    x_a = Float64.(range(0.0, stop=0.05, length=100))
    x_new = [x_a repeat([value(phi2_ph)],100) repeat([value(cat.phih_ph)],100)]
    x_new2 = [x_a repeat([value(phi2_ph)],100) repeat([value(cat2.phih_ph)],100)]
    xarr = Float64.(range(0.0, stop=0.06, length=100))
    
    y = Vector{uwreal}(undef, 100)
    y2 = Vector{uwreal}(undef, 100)
    for j=1:100
        y[j] = fit_par[1] + fit_par[2] * phi2_ph + fit_par[3] * cat.phih_ph + fit_par[4] * xarr[j]# + fit_par[5] * xarr[j] *phi2_ph^2   + fit_par[7]*xarr[j]*cat.phih_ph^2 + fit_par[8]*xarr[j]^4*cat.phih_ph^3
        y2[j] = fit_par2[1] + fit_par2[2] * phi2_ph + fit_par2[3] * cat2.phih_ph + fit_par2[4] * xarr[j]# + fit_par[5] * xarr[j] *phi2_ph^2   + fit_par[7]*xarr[j]*cat.phih_ph^2 + fit_par[8]*xarr[j]^4*cat.phih_ph^3
    end
    uwerr.(y)
    uwerr.(y2)

    figure()
    xx = 1 ./ (8 .* getfield.(ensobs, :t0))
    uwerr.(xx)
    
    errorbar(value.(xx), value.(obs_match),xerr = err.(xx), yerr=err.(obs_match), fmt="s",mfc="none",mec="tomato",ecolor="tomato", capsize=2, label=L"$m_c(m_{\rm{fl-av}})$")
    plot(x_a, model(x_new,value.(fit_par)), color="red",lw=0.5 )
    fill_between(xarr, value.(y) .+ err.(y),value.(y) .- err.(y) , color="tomato", alpha=0.2,zorder=1, lw=0.8)
    errorbar(0, value(best_res), err(best_res), fmt="s", capsize=2, mec="tomato", mfc="tomato", ecolor="tomato")
    
   
    errorbar(value.(xx), value.(obs_match2),xerr = err.(xx), yerr=err.(obs_match2), fmt="s",mfc="none",mec="royalblue",ecolor="royalblue", capsize=2, label=L"$m_c(m_{\eta_c})$")
    plot(x_a, model2(x_new2,value.(fit_par2)), color="blue",lw=0.5 )
    fill_between(xarr, value.(y2) .+ err.(y2),value.(y2) .- err.(y2) , color="royalblue", alpha=0.2,zorder=1, lw=0.8)
    errorbar(0.0005, value(best_res2), err(best_res2), fmt="s", capsize=2, mec="royalblue", mfc="royalblue", ecolor="royalblue")
    
    xlabel(L"$a^2/8t_0$")
    ylabel(ylab)
    ylim(2.95,3.3)
    xlim(-0.003,0.05)
    axvline(0, ls="--", color="black", zorder=1, lw=0.6, label="")
    legend(loc="upper center")
    display(gcf())
    println("par n is ", par_n)
    if save
        path_plot= "/Users/ale/Desktop/plots"
        t = string("fit_muc_cat.pdf")
        savefig(joinpath(path_plot,t))
    end
    close()
end

##
@. lin_mod(x,p) = p[1] + p[2]*x
par, _ = fit_routine(lin_mod, x_fa[:,3], muc, 2, covar=true)
##
x_mh = Float64.(range(minimum(value.(x_fa[:,3]))-1, stop=maximum(value.(x_fa[:,3]))+1, length=100))
y = Vector{uwreal}(undef, 100)
for i in 1:100
    y[i] = par[1] + par[2]*x_mh[i]
end
uwerr.(y)
fill_between(x_mh, value.(y) .+ err.(y),value.(y) .- err.(y),color="tomato", alpha=0.4)
plot(value.(x_fa[:,3]), lin_mod(value.(x_fa[:,3]), value.(par)), lw=0.3, color="tomato")
errorbar(value.(x_fa[:,3]), value.(muc), xerr= err.(x_fa[:,3]),yerr=err.(muc), fmt="s", mfc="none", mec="royalblue",ecolor="royalblue" )
ylim(2.8,3.3)
xlim(3.75, 4.2)
xlabel(L"$\sqrt{8t_0}m_{\bar D}$")
ylabel(L"$M_c^{\rm{RGI}}$")
display(gcf())
t=string("muc_dependence.pdf")
savefig(joinpath("/Users/ale/Desktop/plots",t))
close()
## testing plot_cont_lim
plot_cont_lim(cat_muc[1], f)

##
#=
#======= RESULTS ==========#

#===== CONTINUUM AND CHIRAL EXTRAPOLATION =======#

println("\n Continuum and Chiral Extrapolation \n")

obs_db =Dict(
    "muc"=> [muc],
    "ll" => [m_pi, m_rho, f_pi, f_rho],
    "ls" => [m_k, m_k_star, f_k, f_k_star],
    "lh" => [m_D, m_D_star, f_D, f_D_star],
    "ss" => [m_etaprime, m_phi, f_etaprime, f_phi],
    "sh" => [m_Ds, m_Ds_star, f_Ds, f_Ds_star],
    "hh" => [m_etac, m_jpsi, f_etac, f_jpsi]
)
#=
obs_db =Dict(
    "muc"=> [muc],
    "ll" => [m_pi, m_rho],
    "ls" => [m_k, m_k_star],
    "lh" => [m_D, m_D_star],
    "ss" => [m_etaprime, m_phi],
    "sh" => [m_Ds, m_Ds_star],
    "hh" => [m_etac, m_jpsi]
)
=#

#preparing observables of interest (data, name, ylabel)
obs = Vector{Vector{uwreal}}(undef,0)
ttl_obs = Vector{String}(undef,0)
ylbl = Vector{String}(undef,0)
push!(obs, obs_db["muc"][1])
push!(ttl_obs, ttl_obs_db["muc"][1])
push!(ylbl, ylbl_db["muc"][1])

label = findall(sector)
for lab in label
    for i in 1:length(obs_db[lab])
        push!(obs, obs_db[lab][i])
        push!(ttl_obs, ttl_obs_db[lab][i])
        push!(ylbl, ylbl_db[lab][i])
    end
end
##
# estimate phi2 from database or form analysis if ll sector is computed 
phi2 = Vector{uwreal}(undef,length(ens_list))
sector["ll"] ? phi2 = 8 .* getfield.(ensobs,:t0) .* getfield.(ensobs,:m_ll).^2 : phi2 = 8 .* getfield.(ensobs,:t0) .* getfield.(getfield.(ensobs,:ensinfo),:mpi).^2
phi2_ph = (t0_ph[1] * 139.57039 / hc)^2
uwerr(phi2_ph)
#fit routine 
x = [1 ./(8 .* getfield.(ensobs,:t0)) phi2] #x[1] = a^2 / (8t0), x[2] = 8t0 mpi^2
uwerr.(x)
#modify CL+chiral fit  model
@. cl_chir_model(x, p) = (p[1] + p[2] * x[:, 1]) + (p[3] + p[4] * x[:,1]) * x[:, 2] #linear fits

## FIT PROJECTING TO PHI2=0
obs_t0 = Vector{uwreal}(undef, length(obs)) #sqrt(8t0)obs @ CL & phi2_phys
xarr = Float64.(range(0.0, stop=0.05, length=100))
for k = 1:length(obs)
    par = fit_routine(cl_chir_model, value.(x), obs[k], 4)
    obs_t0[k] = par[1] + par[3] * phi2_ph
    uwerr(obs_t0[k])    
    y = Vector{uwreal}(undef, 100)
    for j=1:100
        y[j] = par[1] + par[2] * xarr[j] + par[3] * phi2_ph
    end
    uwerr.(y)
    figure()
    for b in unique(phi2) #select point with same beta
        nn = findall(x-> x == b, phi2)
        lgnd = string(L"$m_\pi = $", Int32(round(sqrt(value(b))*hc/t0_ph_value[1], sigdigits=3)), " MeV")
        errorbar(value.(x[nn,1]), value.(obs[k][nn]), err.(obs[k][nn]), ms=5, fmt="s", mfc="none", mew=0.8, elinewidth=0.8, capsize=2, label=lgnd)
    end
    fill_between(xarr, value.(y) .+ err.(y),value.(y) .- err.(y) , color="tomato", alpha=0.4)
    lgnd=L"$\mathrm{CL}$"
    errorbar(0, value(obs_t0[k]), err(obs_t0[k]), fmt="s", zorder=2, ms=4,  mfc="red", c = "red", mew=0.8, elinewidth=1, capsize=2, label=lgnd)
    axvline(0, ls="--", color="black", zorder=1, lw=0.6, label="")
    xlabel(L"$a^2/8t_0$")
    ylabel(ylbl[k])
    xlim(-0.002,0.05)
    #ylim(2.8,3.4)
    legend(ncol=2)
    display(gcf())
    t = string("fit_phi2=0", ttl_obs[k], ".pdf")
    savefig(joinpath(path_plot, t))
    #savefig(joinpath("/Users/ale/Desktop/plottest", t))
    close()

end

## FIT PROJECTING TO a=0
xarr = Float64.(range(0.0, stop=0.9, length=100))
for k = 1:length(obs)
    par = fit_routine(cl_chir_model, value.(x), obs[k], 4)   
    y = Vector{uwreal}(undef, 100)
    for j=1:100
        y[j] = par[1]  + par[3] * xarr[j]# phi2_ph
    end
    uwerr.(y)
    figure()
    for b in unique(getfield.(ensinfo,:beta)) #select point with same beta
        nn = findall(x-> x == b, getfield.(ensinfo,:beta))
        lgnd = string(L"$\beta = $", b)
        errorbar(value.(x[nn,2]), value.(obs[k][nn]), err.(obs[k][nn]), err.(x[nn,2]), fmt="x", label=lgnd)
    end
    fill_between(xarr, value.(y) .+ err.(y),value.(y) .- err.(y) , color="tomato", alpha=0.4)
    lgnd=L"$\mathrm{CL}$"
    errorbar(0, value(obs_t0[k]), err(obs_t0[k]), fmt="s", zorder=2, ms=4,  mfc="red", c = "red", mew=0.8, elinewidth=1, capsize=2, label=lgnd)
    axvline(0, ls="--", color="black", zorder=1, lw=0.6, label="")
    xlabel(L"$\Phi_2$")
    ylabel(ylbl[k])
    xlim(-0.002,0.9)
    #ylim(2.8,3.4)
    legend(ncol=2)
    display(gcf())
    t = string("fit_a=0", ttl_obs[k], ".pdf")
    savefig(joinpath(path_plot, t))
    #savefig(joinpath("/Users/ale/Desktop/plottest", t))
    close()

end

obs_ph = Vector{uwreal}(undef, length(obs))
for k = 1:length(obs)
    println(ylbl[k], " = ", obs_t0[k])
    #phys
    obs_ph[k] = obs_t0[k] * hc / t0_ph[1]
    uwerr(obs_ph[k])
    println(ttl_obs[k], "(MeV) = ", obs_ph[k])
end


## TRYING TO ESTIMATE CHARM MASS WITH DIFFERENT MODELS TO ADDRESS SYSTEMATICS

# estimate phi2 from database or form analysis if ll sector is computed 
phi2 = Vector{uwreal}(undef,length(ens_list))
sector["ll"] ? phi2 = 8 .* getfield.(ensobs,:t0) .* getfield.(ensobs,:m_ll).^2 : phi2 = 8 .* getfield.(ensobs,:t0) .* getfield.(getfield.(ensobs,:ensinfo),:mpi).^2
phih = Vector{uwreal}(undef, length(ens_list))
phih = sqrt.( 8 .* getfield.(ensobs, :t0)) .*getfield.(ensobs, :m_hh_match)  
phih_ph =  M_values[5] * t0_ph[1] / hc
#phih = sqrt.( 8 .* getfield.(ensobs, :t0)) .*(2/3 .* getfield.(ensobs, :m_lh_match) .+ 1/3 .* getfield.(ensobs, :m_sh_match))
#phih_ph =  (2/3 * M_values[1] + 1/3 * M_values[3]) * t0_ph[1] / hc

phi2_ph = (t0_ph[1] * 139.57039 / hc)^2
uwerr(phi2_ph)
#fit routine 
x = [1 ./(8 .* getfield.(ensobs,:t0)) phi2 phih] #x[1] = a^2 / (8t0), x[2] = 8t0 mpi^2, x[3] = sqrt(8t0) m_flav_av
uwerr.(x)
#modify CL+chiral fit  model
@. cl_chir_model(x, p) = (p[1] + p[2] * x[:, 1] ) + (p[3]) * x[:, 2] + p[4] * x[:,1] * x[:,3].^2 #linear fits

test_charm = uwreal(0.0)
xarr = Float64.(range(0.0, stop=0.05, length=100))
for k = [1:1]
    par = fit_routine(cl_chir_model, value.(x), muc, 4)
    test_charm = par[1] + par[3] * phi2_ph # + par[4] * phih_ph^2
    uwerr(test_charm)    
    y = Vector{uwreal}(undef, 100)
    for j=1:100
        y[j] = par[1] + par[2] * xarr[j] + par[3] * phi2_ph 
    end
    uwerr.(y)
    figure()
    for b in unique(phi2) #select point with same beta
        nn = findall(x-> x == b, phi2)
        lgnd = string(L"$m_\pi = $", Int32(round(sqrt(value(b))*hc/t0_ph_value[1], sigdigits=3)), " MeV")
        errorbar(value.(x[nn,1]), value.(muc[nn]), err.(muc[nn]), ms=5, fmt="s", mfc="none", mew=0.8, elinewidth=0.8, capsize=2, label=lgnd)
    end
    fill_between(xarr, value.(y) .+ err.(y),value.(y) .- err.(y) , color="tomato", alpha=0.4)
    lgnd=L"$\mathrm{CL}$"
    errorbar(0, value(test_charm), err(test_charm), fmt="s", zorder=2, ms=4,  mfc="red", c = "red", mew=0.8, elinewidth=1, capsize=2, label=lgnd)
    axvline(0, ls="--", color="black", zorder=1, lw=0.6, label="")
    xlabel(L"$a^2/8t_0$")
    #ylabel(ylbl[k])
    xlim(-0.002,0.05)
    ylim(2.4,3.4)
    legend(ncol=2)
    display(gcf())
    t = string("fit_phi2=0", ttl_obs[k], ".pdf")
    #savefig(joinpath(path_plot, t))
    #savefig(joinpath("/Users/ale/Desktop/plottest", t))
    close()

end

test_charm_phys = test_charm * hc / t0_ph[1]
uwerr(test_charm_phys)
println("\n Results in the continuum limit \n \n")
println( ylbl[1], " = ", test_charm, "\n")
#phys
println(ttl_obs[1], "(MeV) = ", test_charm_phys, "\n\n")
    



##
#======== STORE RESULTS ========#

open(joinpath(path_results, "results.txt"), "w") do f 
    print(f, "GEVP analysis results", "\n \n")
    print(f, "#================================# \n \n")
    print(f, "Setup:\n")
    print(f, "Ensembles analysed: ", ens_list, "\n")
    print(f, "Data storage: ", path_data, "\n")
    print(f, "Plateaux file: ", path_plat, "\n")
    print(f, "Results storage: ", path_results, "\n")
    print(f, "Sector analysed: ", findall(sector), "\n")
    print(f, "Reweighting factor: ", rwf, "\n")
    print(f, "Mass shift: ", mass_shift, "\n")
    if compute_t0
        print(f, "t0 values: computed from the ms.dat files \n")
    else
        print(f, "t0 values: extracted from const.jl \n")
    end
    if sector["ll"]
        print(f, "Phi2 = 8t0m_pi^2: m_pi computed from mesons.dat files \n")
    else
        print(f, "Phi2 = 8t0m_pi^2: m_pi extracted from ens_db in const.jl \n")
    end
    print(f, " \n#================================# \n \n")
    print(f, "\n Results at finite lattice spacings \n \n")

    lab = findall(sector)
    for i in 1:length(ens_list)
        print(f, "Ensemble ", ensobs[i].ensinfo.id, "\n")
        for j in 1:length(obs)
            print(f, ylbl[j], " = ", obs[j][i], "\n")
        end
        print(f, "\n")
    end

    print(f, " \n#================================# \n \n")
    print(f, "\n Results in the continuum limit \n \n")
    for k = 1:length(obs)
        print(f, ylbl[k], " = ", obs_t0[k], "\n")
        #phys
        print(f, ttl_obs[k], "(MeV) = ", obs_ph[k], "\n\n")
    end
end



=#